unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, StdCtrls, Grids;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    FStringGrid: TStringGrid;
  end;

type

  { TMyStringGrid }

  TMyStringGrid = class(TStringGrid)
  private
    fLeftColWidth: Integer;
    fOrgEditingDown: TNotifyEvent;
    procedure SetLeftColWidth(aValue: Integer);
    procedure NewEditingDown(Sender: TObject);
  public
    constructor Create(AOwner : TComponent); override;
    destructor Destroy; override;
  published
    property LeftColWidth : Integer read fLeftColWidth write SetLeftColWidth;
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
  if Assigned(FStringGrid) then Exit;
  Button1.Visible := False;
  FStringGrid     := TMyStringGrid.Create(Self);
  with FStringGrid do
  begin
    Parent   := Self;
    Anchors  := [akLeft, akRight, akTop, akBottom];
    Options  := Options + [goEditing];
    RowCount := 5;
    SetBounds(10, 10, Form1.Width - 20, Form1.Height - 20);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  FStringGrid := nil;
end;

{ TMyStringGrid }

procedure TMyStringGrid.SetLeftColWidth(aValue: Integer);
begin
  if fLeftColWidth <> aValue then
  begin
    fLeftColWidth := aValue;
    ColWidths[0]  := fLeftColWidth;
  end;
  Invalidate;
end;

procedure TMyStringGrid.NewEditingDown(Sender: TObject);
begin
  AlternateColor := Random($FFFFFF);
  Invalidate;
  if Assigned(fOrgEditingDown) then
    fOrgEditingDown(Sender);
end;

constructor TMyStringGrid.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  fOrgEditingDown := OnEditingDone;
  OnEditingDone   := @NewEditingDown;
  AlternateColor  := clMoneyGreen;
  Color           := clCream;
  fLeftColWidth   := 20;
  ColWidths[0]    := fLeftColWidth;
  RowCount        := 1;
  ColCount        := 3;
  AutoFillColumns := True;
end;

destructor TMyStringGrid.Destroy;
begin
  inherited Destroy;
end;

end.
